Package: aroma.cn
Version: 1.7.1
Depends: R (>= 3.1.2), R.utils (>= 2.11.0), aroma.core (>= 3.2.2)
Imports: R.methodsS3 (>= 1.8.1), R.oo (>= 1.24.0), R.filesets (>=
        2.14.0), R.cache (>= 0.15.0), matrixStats (>= 0.61.0), PSCBS
        (>= 0.65.0), future.apply
Suggests: aroma.light (>= 2.2.1), DNAcopy (>= 1.40.0), GLAD (>= 1.12.0)
SuggestsNote: BioC (>= 3.0), Recommended: aroma.light, DNAcopy
Title: Copy-Number Analysis of Large Microarray Data Sets
Authors@R: c(
  person("Henrik", "Bengtsson", role=c("aut", "cre", "cph"),
                                 email="henrikb@braju.com"),
  person("Pierre", "Neuvial", role="aut"))
Description: Methods for analyzing DNA copy-number data.  Specifically,
  this package implements the multi-source copy-number normalization (MSCN)
  method for normalizing copy-number data obtained on various platforms and
  technologies.  It also implements the TumorBoost method for normalizing
  paired tumor-normal SNP data.
License: LGPL (>= 2.1)
LazyLoad: TRUE
biocViews: ProprietaryPlatforms, aCGH, CopyNumberVariants, SNP,
        Microarray, OneChannel, TwoChannel, DataImport,
        DataRepresentation, Preprocessing, QualityControl
URL: https://www.aroma-project.org/,
        https://github.com/HenrikBengtsson/aroma.cn
BugReports: https://github.com/HenrikBengtsson/aroma.cn/issues
NeedsCompilation: no
Packaged: 2024-02-17 19:57:52 UTC; henrik
Author: Henrik Bengtsson [aut, cre, cph],
  Pierre Neuvial [aut]
Maintainer: Henrik Bengtsson <henrikb@braju.com>
Repository: CRAN
Date/Publication: 2024-02-17 20:30:02 UTC
Built: R 4.6.0; ; 2026-04-28 14:15:01 UTC; unix

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# IMPORTS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
importFrom("R.methodsS3", "setMethodS3")
importFrom("R.oo", "setConstructorS3")

## Importing Class:es
importFrom("R.oo", "BasicObject")
importFrom("R.oo", "Object")
importFrom("R.oo", "Class")
importFrom("R.oo", "Package")
importFrom("R.utils", "GenericSummary")
importFrom("R.filesets", "GenericDataFile")
importFrom("R.filesets", "GenericDataFileSet")
importFrom("aroma.core", "AromaTransform")
importFrom("aroma.core", "AromaUnitGenotypeCallFile")
importFrom("aroma.core", "AromaUnitGenotypeCallSet")
importFrom("aroma.core", "AromaUnitSignalBinaryFile")
importFrom("aroma.core", "AromaUnitSignalBinarySet")
importFrom("aroma.core", "AromaUnitPscnBinarySet")
importFrom("aroma.core", "CopyNumberRegions")
importFrom("aroma.core", "RawAlleleBFractions")

## Importing generics
importFrom("aroma.core", "binnedSmoothing")
importFrom("aroma.core", "fit")
importFrom("aroma.core", "getChipType")
importFrom("aroma.core", "getChromosomes") ## Multi-sources: aroma.core, PSCBS
importFrom("aroma.core", "getFitFunction")
importFrom("aroma.core", "getInputDataSet")
importFrom("aroma.core", "getOptionalArguments")
importFrom("aroma.core", "getOutputDataSet")
importFrom("aroma.core", "getOutputDataSet0")
importFrom("aroma.core", "getOutputFiles")
importFrom("aroma.core", "getParameters")
importFrom("aroma.core", "getPlatform")
importFrom("aroma.core", "getRandomSeed")
importFrom("aroma.core", "getRootPath")
importFrom("aroma.core", "getXScale")
importFrom("aroma.core", "getYScale")
importFrom("aroma.core", "isHeterozygous")
importFrom("aroma.core", "isHomozygous")
importFrom("aroma.core", "kernelSmoothing")
importFrom("aroma.core", "loadFit")
importFrom("aroma.core", "nbrOfLoci") ## Multi-sources: aroma.core, PSCBS
importFrom("aroma.core", "normalizeTumorBoost") ## Multi-sources: aroma.core, aroma.light
importFrom("aroma.core", "plotTracks") ## Multi-sources: aroma.core, PSCBS
importFrom("aroma.core", "process")
importFrom("aroma.core", "setRandomSeed")
importFrom("R.filesets", "byName")
importFrom("R.filesets", "byPath")
importFrom("R.filesets", "dsApplyInPairs")
importFrom("R.filesets", "findByName")
importFrom("R.filesets", "getAsteriskTags")
importFrom("R.filesets", "getDefaultFullName")
importFrom("R.filesets", "getFullName")
importFrom("R.filesets", "getNames")
importFrom("R.filesets", "getTags")
importFrom("R.filesets", "indexOf")
importFrom("R.filesets", "nbrOfFiles")
importFrom("R.filesets", "setTags")
importFrom("R.oo", "getCalls")
importFrom("R.oo", "getName") ## Multi-sources: R.oo, R.filesets
importFrom("R.oo", "getPath") ## Multi-sources: R.oo, R.filesets
importFrom("R.utils", "loadObject")


## Importing functions
importFrom("aroma.core", "asThis")
importFrom("aroma.core", "callNaiveGenotypes") ## Multi-sources: aroma.core, aroma.light
importFrom("aroma.core", "colMeans") ## Multi-sources: aroma.core, base
importFrom("aroma.core", "drawLevels") ## Multi-sources: aroma.core, PSCBS
importFrom("aroma.core", "dropSegmentationOutliers") ## Multi-sources: aroma.core, PSCBS
importFrom("aroma.core", "extractCopyNumberRegions")
importFrom("aroma.core", "extractGenotypes")
importFrom("aroma.core", "extractRawCopyNumbers")
importFrom("aroma.core", "extractRegion") ## Multi-sources: aroma.core, PSCBS
importFrom("aroma.core", "extractRegions") ## Multi-sources: aroma.core, PSCBS
importFrom("aroma.core", "findLargeGaps") ## Multi-sources: aroma.core, PSCBS
importFrom("aroma.core", "getAromaUgpFile")
importFrom("aroma.core", "getLocusData") ## Multi-sources: aroma.core, PSCBS
importFrom("aroma.core", "getParametersAsString")
importFrom("aroma.core", "getPositions")
importFrom("aroma.core", "getSignals")
importFrom("aroma.core", "getUnitsOnChromosome")
importFrom("aroma.core", "getUnitsOnChromosomes")
importFrom("aroma.core", "nbrOfRegions")
importFrom("aroma.core", "nbrOfUnits")
importFrom("aroma.core", "processTime")
importFrom("aroma.core", "readFooter")
importFrom("aroma.core", "require") ## Multi-sources: aroma.core, base
importFrom("aroma.core", "segmentByCBS") ## Multi-sources: aroma.core, PSCBS
importFrom("aroma.core", "updateGenotypes")
importFrom("aroma.core", "writeFooter")
importFrom("aroma.core", "xRange")
importFrom("aroma.core", "colBinnedSmoothing.matrix")
importFrom("aroma.core", "colKernelSmoothing.matrix")

if (FALSE) { # Only suggesting aroma.light for now
  importFrom("aroma.light", "backtransformPrincipalCurve")
  importFrom("aroma.light", "backtransformXYCurve")
  importFrom("aroma.light", "findPeaksAndValleys")
  importFrom("aroma.light", "fitPrincipalCurve")
  importFrom("aroma.light", "fitXYCurve")
  importFrom("aroma.light", "normalizeDifferencesToAverage")
  importFrom("aroma.light", "robustSmoothSpline")
}
importFrom("matrixStats", "colDiffs")
importFrom("matrixStats", "colSds")
importFrom("matrixStats", "rowAlls")
importFrom("matrixStats", "rowMins")
importFrom("matrixStats", "weightedMedian")
importFrom("PSCBS", "bootstrapSegmentsAndChangepoints")
importFrom("PSCBS", "bootstrapTCNandDHByRegion")
importFrom("PSCBS", "callCopyNeutral")
importFrom("PSCBS", "dropRegions")
importFrom("PSCBS", "estimateDeltaAB")
importFrom("PSCBS", "estimateKappa")
importFrom("PSCBS", "extractC1C2")
importFrom("PSCBS", "extractDhSegment")
importFrom("PSCBS", "extractLocusLevelC1C2")
importFrom("PSCBS", "extractLocusLevelTCN")
importFrom("PSCBS", "gapsToSegments")
importFrom("PSCBS", "getMeanEstimators")
importFrom("PSCBS", "getSegments")
importFrom("PSCBS", "linesC1C2")
importFrom("PSCBS", "mergeTwoSegments")
importFrom("PSCBS", "nbrOfSegments")
importFrom("PSCBS", "plotC1C2")
importFrom("PSCBS", "plotTracks2")
importFrom("PSCBS", "postsegmentTCN")
importFrom("PSCBS", "setSampleName")
importFrom("R.cache", "loadCache")
importFrom("R.cache", "saveCache")
importFrom("R.filesets", "append") ## Multi-sources: R.filesets, PSCBS, base
importFrom("R.filesets", "extractMatrix")
importFrom("R.filesets", "getChecksum") ## Multi-sources: R.filesets, R.cache
importFrom("R.filesets", "getFile")
importFrom("R.filesets", "getFileClass")
importFrom("R.filesets", "getFilenameExtension")
importFrom("R.filesets", "getFileSize")
importFrom("R.filesets", "getFullNames")
importFrom("R.filesets", "getFullNameTranslator")
importFrom("R.filesets", "getPathname")
importFrom("R.filesets", "readDataFrame")
importFrom("R.filesets", "setFullNamesTranslator")
importFrom("R.oo", "throw")
importFrom("R.oo", "clone") ## Multi-sources: R.oo, R.filesets
importFrom("R.oo", "equals")
importFrom("R.oo", "extend")
importFrom("R.oo", "getVersion")
importFrom("R.oo", "newInstance")
importFrom("R.oo", "objectSize")
importFrom("R.oo", "startupMessage")
importFrom("R.oo", "trim")
importFrom("R.oo", "uses")
importFrom("R.utils", "callHooks")
importFrom("R.utils", "capitalize")
importFrom("R.utils", "cat") ## Multi-sources: R.utils, base
importFrom("R.utils", "copyFile")
importFrom("R.utils", "draw")
importFrom("R.utils", "enter")
importFrom("R.utils", "exit")
importFrom("R.utils", "extract") ## Multi-sources: R.utils, R.filesets
importFrom("R.utils", "filePath")
importFrom("R.utils", "getAbsolutePath")
importFrom("R.utils", "getFilename") ## Multi-sources: R.utils, R.filesets
importFrom("R.utils", "getParent")
importFrom("R.utils", "hpaste")
importFrom("R.utils", "isDirectory")
importFrom("R.utils", "isDone")
importFrom("R.utils", "isFile") ## Multi-sources: R.utils, R.filesets
importFrom("R.utils", "less")
importFrom("R.utils", "mkdirs")
importFrom("R.utils", "popState")
importFrom("R.utils", "popTemporaryFile")
importFrom("R.utils", "printf")
importFrom("R.utils", "pushState")
importFrom("R.utils", "pushTemporaryFile")
importFrom("R.utils", "resample")
importFrom("R.utils", "saveObject")
importFrom("R.utils", "seqToHumanReadable")
importFrom("R.utils", "stext")
importFrom("R.utils", "subplots")
importFrom("R.utils", "use")

# Manual imports
importFrom("PSCBS", "callROH")
importFrom("PSCBS", "callLOH")
importFrom("PSCBS", "callAB")
importFrom("R.utils", "Arguments")

importFrom("future.apply", "future_mapply")

importFrom("graphics",
           "abline", "axis", "box", "grid", "layout",
           "lines", "pairs", "par", "plot", "plot.new", "points",
           "title")

importFrom("stats",
           "coef", "cor", "density", "lm", "loess", "median",
           "na.omit", "pchisq", "pnorm", "predict", "qnorm", "sd",
           "smooth.spline", "t.test", "var.test")

importFrom("utils", "head", "str")


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# EXPORTS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Export all public methods, that is, those without a preceeding dot
# in their names.
exportPattern("^[^\\.]")

##export("getAsteriskTags")  # Re-exported from aroma.core (from R.filesets)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# S3 DECLARATIONS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AbstractCBS
S3method("pruneCNA", "AbstractCBS")

# AbstractCurveNormalization
S3method("as.character", "AbstractCurveNormalization")
S3method("backtransformOne", "AbstractCurveNormalization")
S3method("fitOne", "AbstractCurveNormalization")
S3method("getAsteriskTags", "AbstractCurveNormalization")
S3method("getDataSets", "AbstractCurveNormalization")
S3method("getFullName", "AbstractCurveNormalization")
S3method("getInputDataSet", "AbstractCurveNormalization")
S3method("getName", "AbstractCurveNormalization")
S3method("getOutputDataSet", "AbstractCurveNormalization")
S3method("getPairedDataSet", "AbstractCurveNormalization")
S3method("getPath", "AbstractCurveNormalization")
S3method("getRootPath", "AbstractCurveNormalization")
S3method("getSubsetToFit", "AbstractCurveNormalization")
S3method("getTags", "AbstractCurveNormalization")
S3method("getTargetDataSet", "AbstractCurveNormalization")
S3method("nbrOfFiles", "AbstractCurveNormalization")
S3method("process", "AbstractCurveNormalization")
S3method("setTags", "AbstractCurveNormalization")

# AromaUnitPscnBinarySet
S3method("doSegmentByPairedPSCBS", "AromaUnitPscnBinarySet")

# AromaUgpFile
S3method("findLargeGaps", "AromaUgpFile")

# AromaUnitPscnBinarySet
S3method("findLargeGaps", "AromaUnitPscnBinarySet")

# C1C2
S3method("fitLoess2D", "C1C2")
S3method("normalizeLoess2D", "C1C2")
S3method("plot", "C1C2")
S3method("points", "C1C2")

# CartesianSnpData
S3method("asCartesianSnpData", "CartesianSnpData")
S3method("asPolarSnpData", "CartesianSnpData")
S3method("asTotalFracBSnpData", "CartesianSnpData")
S3method("pairedBoost", "CartesianSnpData")
S3method("plot", "CartesianSnpData")

# CBS
S3method("findAtomicAberrations", "CBS")

# CopyNumberRegions
S3method("findAtomicAberrations", "CopyNumberRegions")
S3method("getXScale", "CopyNumberRegions")
S3method("getYScale", "CopyNumberRegions")
S3method("plot", "CopyNumberRegions")

# data.frame
S3method("calculatePairedPSCNByGenotype", "data.frame")
S3method("fitLoessKD", "data.frame")
S3method("normalizeLoessKD", "data.frame")

# default
S3method("testAllelicBalanceByBAFs", "default")

# list
S3method("extractC1C2", "list")

# matrix
S3method("fitLoessKD", "matrix")
S3method("normalizeLoessKD", "matrix")
S3method("normalizeMirroredBAFsByRegions", "matrix")
S3method("normalizePrincipalCurve", "matrix")

# MultiSourceCopyNumberNormalization
S3method("as.character", "MultiSourceCopyNumberNormalization")
S3method("extractTupleOfDataFiles", "MultiSourceCopyNumberNormalization")
S3method("fitOne", "MultiSourceCopyNumberNormalization")
S3method("getAllNames", "MultiSourceCopyNumberNormalization")
S3method("getAsteriskTags", "MultiSourceCopyNumberNormalization")
S3method("getFitAromaUgpFile", "MultiSourceCopyNumberNormalization")
S3method("getInputDataSets", "MultiSourceCopyNumberNormalization")
S3method("getOutputDataSets", "MultiSourceCopyNumberNormalization")
S3method("getOutputPaths", "MultiSourceCopyNumberNormalization")
S3method("getParameters", "MultiSourceCopyNumberNormalization")
S3method("getPrincipalCurveEstimator", "MultiSourceCopyNumberNormalization")
S3method("getSmoothedDataSets", "MultiSourceCopyNumberNormalization")
S3method("getSubsetToFit", "MultiSourceCopyNumberNormalization")
S3method("getTags", "MultiSourceCopyNumberNormalization")
S3method("nbrOfDataSets", "MultiSourceCopyNumberNormalization")
S3method("normalizeOne", "MultiSourceCopyNumberNormalization")
S3method("plotSmoothedPairsOne", "MultiSourceCopyNumberNormalization")
S3method("process", "MultiSourceCopyNumberNormalization")

# NaiveFracBGenotyping
S3method("getDataSet", "NaiveFracBGenotyping")
S3method("getGenotypeCallSet", "NaiveFracBGenotyping")
S3method("nbrOfLoci", "NaiveFracBGenotyping")
S3method("nbrOfSNPs", "NaiveFracBGenotyping")
S3method("process", "NaiveFracBGenotyping")
S3method("processOne", "NaiveFracBGenotyping")

# numeric
S3method("calculatePairedPSCNByGenotype", "numeric")
S3method("calculateTumorPSCNByGenotypeUsingCTCN", "numeric")
S3method("callXXorXY", "numeric")

# PairedPSCBS
S3method("backgroundCorrect", "PairedPSCBS")
S3method("bootstrap", "PairedPSCBS")
S3method("callAllelicBalanceByBAFs", "PairedPSCBS")
S3method("callCopyNeutralRegions", "PairedPSCBS")
S3method("drawC1C2Density", "PairedPSCBS")
S3method("estimateC2Bias", "PairedPSCBS")
S3method("findAtomicAberrations", "PairedPSCBS")
S3method("fitC1C2Densities", "PairedPSCBS")
S3method("fitC1C2Peaks", "PairedPSCBS")
S3method("normalizeBAFsByRegions", "PairedPSCBS")
S3method("plotC1C2Grid", "PairedPSCBS")
S3method("resampleA", "PairedPSCBS")
S3method("resampleB", "PairedPSCBS")
S3method("resampleC", "PairedPSCBS")
S3method("transformC1C2", "PairedPSCBS")
S3method("translateC1C2", "PairedPSCBS")

# PairedPscbsCaller
S3method("getAsteriskTags", "PairedPscbsCaller")
S3method("getOptionalArguments", "PairedPscbsCaller")
S3method("getParameters", "PairedPscbsCaller")
S3method("getPath", "PairedPscbsCaller")
S3method("getPlatform", "PairedPscbsCaller")
S3method("getRootPath", "PairedPscbsCaller")
S3method("process", "PairedPscbsCaller")

# PairedPSCBSFile
S3method("loadFit", "PairedPSCBSFile")
S3method("loadObject", "PairedPSCBSFile")

# PairedPSCBSFileSet
S3method("byName", "PairedPSCBSFileSet")
S3method("byPath", "PairedPSCBSFileSet")
S3method("findByName", "PairedPSCBSFileSet")
S3method("getChipType", "PairedPSCBSFileSet")
S3method("getDefaultFullName", "PairedPSCBSFileSet")
S3method("getPlatform", "PairedPSCBSFileSet")

# PairedPscbsModel
S3method("as.character", "PairedPscbsModel")
S3method("fit", "PairedPscbsModel")
S3method("getAsteriskTags", "PairedPscbsModel")
S3method("getChipType", "PairedPscbsModel")
S3method("getChromosomes", "PairedPscbsModel")
S3method("getDataSets", "PairedPscbsModel")
S3method("getFitFunction", "PairedPscbsModel")
S3method("getFullName", "PairedPscbsModel")
S3method("getName", "PairedPscbsModel")
S3method("getNormalDataSet", "PairedPscbsModel")
S3method("getOptionalArguments", "PairedPscbsModel")
S3method("getOutputDataSet", "PairedPscbsModel")
S3method("getParameters", "PairedPscbsModel")
S3method("getPath", "PairedPscbsModel")
S3method("getRandomSeed", "PairedPscbsModel")
S3method("getRootPath", "PairedPscbsModel")
S3method("getTags", "PairedPscbsModel")
S3method("getTumorDataSet", "PairedPscbsModel")
S3method("indexOf", "PairedPscbsModel")
S3method("nbrOfFiles", "PairedPscbsModel")
S3method("setRandomSeed", "PairedPscbsModel")
S3method("setTags", "PairedPscbsModel")

# PeaksAndValleys
S3method("callPeaks", "PeaksAndValleys")

# PolarSnpData
S3method("asCartesianSnpData", "PolarSnpData")
S3method("asPolarSnpData", "PolarSnpData")
S3method("asTotalFracBSnpData", "PolarSnpData")
S3method("pairedBoost", "PolarSnpData")
S3method("plot", "PolarSnpData")

# principal.curve
S3method("pairs2", "principal.curve")

# PrincipalCurve
S3method("getBacktransforms", "PrincipalCurve")
S3method("plotBacktransforms", "PrincipalCurve")

# PrincipalCurveNormalization
S3method("backtransformOne", "PrincipalCurveNormalization")
S3method("fitOne", "PrincipalCurveNormalization")
S3method("getSubsetToFit", "PrincipalCurveNormalization")

# PruneCNA
S3method("[", "PruneCNA")
S3method("extractGenerations", "PruneCNA")
S3method("nbrOfGenerations", "PruneCNA")
S3method("plotTracks", "PruneCNA")

# RawAlleleBFractions
S3method("callGenotypes", "RawAlleleBFractions")
S3method("normalizeTumorBoost", "RawAlleleBFractions")

# RawGenomicSignals
S3method("segmentByPruneCBS", "RawGenomicSignals")
S3method("segmentByPruneCBSv1", "RawGenomicSignals")

# RawGenotypeCalls
S3method("getCalls", "RawGenotypeCalls")
S3method("getColors", "RawGenotypeCalls")
S3method("isHeterozygous", "RawGenotypeCalls")
S3method("isHomozygous", "RawGenotypeCalls")

# SnpData
S3method("callGenotypes", "SnpData")

# TotalCnBinnedSmoothing
S3method("getAsteriskTags", "TotalCnBinnedSmoothing")
S3method("getParameters", "TotalCnBinnedSmoothing")
S3method("smoothRawCopyNumbers", "TotalCnBinnedSmoothing")

# TotalCnKernelSmoothing
S3method("getAsteriskTags", "TotalCnKernelSmoothing")
S3method("getParameters", "TotalCnKernelSmoothing")
S3method("smoothRawCopyNumbers", "TotalCnKernelSmoothing")

# TotalCnSmoothing
S3method("getAsteriskTags", "TotalCnSmoothing")
S3method("getOutputDataSet0", "TotalCnSmoothing")
S3method("getOutputFileClass", "TotalCnSmoothing")
S3method("getOutputFileExtension", "TotalCnSmoothing")
S3method("getOutputFiles", "TotalCnSmoothing")
S3method("getOutputFileSetClass", "TotalCnSmoothing")
S3method("getParameters", "TotalCnSmoothing")
S3method("getPath", "TotalCnSmoothing")
S3method("getRootPath", "TotalCnSmoothing")
S3method("getTargetPositions", "TotalCnSmoothing")
S3method("getTargetUgpFile", "TotalCnSmoothing")
S3method("process", "TotalCnSmoothing")
S3method("smoothRawCopyNumbers", "TotalCnSmoothing")

# TotalFracBSnpData
S3method("asCartesianSnpData", "TotalFracBSnpData")
S3method("asPolarSnpData", "TotalFracBSnpData")
S3method("asTotalFracBSnpData", "TotalFracBSnpData")
S3method("callGenotypes", "TotalFracBSnpData")
S3method("pairedBoost", "TotalFracBSnpData")
S3method("plot", "TotalFracBSnpData")

# TumorBoostNormalization
S3method("as.character", "TumorBoostNormalization")
S3method("getAsteriskTags", "TumorBoostNormalization")
S3method("getDataSets", "TumorBoostNormalization")
S3method("getFlavor", "TumorBoostNormalization")
S3method("getFullName", "TumorBoostNormalization")
S3method("getInputDataSet", "TumorBoostNormalization")
S3method("getName", "TumorBoostNormalization")
S3method("getNormalDataSet", "TumorBoostNormalization")
S3method("getNormalGenotypeCallSet", "TumorBoostNormalization")
S3method("getOutputDataSet", "TumorBoostNormalization")
S3method("getPath", "TumorBoostNormalization")
S3method("getRootPath", "TumorBoostNormalization")
S3method("getTags", "TumorBoostNormalization")
S3method("nbrOfFiles", "TumorBoostNormalization")
S3method("process", "TumorBoostNormalization")
S3method("setTags", "TumorBoostNormalization")

# XYCurveNormalization
S3method("backtransformOne", "XYCurveNormalization")
S3method("fitOne", "XYCurveNormalization")

textRegion <- function(region=NULL, ...) {
  # Arguments 'region':
  if (is.null(region)) {
    query <- "Set region in Mb: ";
  } else {
    region <- Arguments$getDoubles(region, range=c(0,999), length=c(2,2));
    currRegion <- sprintf("%.2f-%.2f Mb", region[1], region[2]);
    query <- sprintf("Set region (now %s): ", currRegion);
  }

  newRegion <- NULL;
  while (length(newRegion) != 2) {
    newRegion <- textNumericVector(query=query, default=region);
  }

  newRegion;
} # textRegion()


textNumericVector <- function(query="Enter numeric vector: ", default=NULL, ...) {
  # Arguments 'default':
  if (!is.null(default)) {
    default <- Arguments$getNumerics(default, ...);
  }

  ans <- NULL;
  while (length(ans) == 0) {
    cat(query);
    ans <- textCharacterVector(query=query, default=default, ...);
    ans <- as.double(ans);
    ans <- ans[is.finite(ans)];
    ans0 <- ans;
    ans <- NULL;
    tryCatch({
      ans <- Arguments$getNumerics(ans0, ...);
    }, error = function(ex) {
      print(ex$message);
    });
  }

  ans;
} # textNumericVector()


textCharacterVector <- function(query="Enter character vector: ", default=NULL, ...) {
  # Arguments 'default':
  if (!is.null(default)) {
    default <- Arguments$getCharacters(default, ...);
  }

  ans <- NULL;
  while (length(ans) == 0) {
    cat(query);
    ans <- readline();
    if (identical(ans, "@@@")) {
      return(default);
    }
    ans <- strsplit(ans, split="[,]")[[1]];
    # Return default value
    ans <- sapply(ans, FUN=trim);
    ans0 <- ans;
    ans <- NULL;
    tryCatch({
      ans <- Arguments$getCharacters(ans0, ...);
    }, error = function(ex) {
      print(ex$message);
    });
  }

  ans;
} # textCharacterVector()


textPlotAnnotations <- function(pa=NULL, ...) {
  paDefault <- list(
    xScale = 1e-6,
    Clim = c(0,6),
    width = 640,
    height = 240,
    rawCol = "#999999",
    smoothCol = "NA",
    smoothCex = 1.5,
    showSampleName = FALSE,
    showChr = FALSE,
    xlab = "",
    ylab = ""
  );

  if (identical(pa, "default")) {
    return(paDefault);
  }

  if (is.null(pa)) {
    pa <- paDefault;
  }

  pa0 <- pa;

  while (TRUE) {
    str(pa);
    names <- names(pa);
    names(names) <- seq_along(names);
    choices <- c(names, r="RESET", s="SAVE", c="CANCEL");
    choice <- textMenu(choices, title="Select attribute:", value=FALSE);
    choiceStr <- names(choices)[choice];
    if (choiceStr == "c") {
      return(pa0);
    } else if (choiceStr == "s") {
      return(pa);
    } else if (choiceStr == "r") {
      pa <- paDefault;
    } else {
      name <- choices[choice];
      default <- pa[[name]];
      cat(sprintf("Current value (length=%d):\n", length(default)));
      print(default);
      length <- rep(length(default),2);
      if (is.character(default)) {
        query <- "Enter value: ";
        ans <- textCharacterVector(query=query, default=default, length=length);
      } else if (is.numeric(default)) {
        query <- "Enter a numeric vector: ";
        ans <- textNumericVector(query=query, default=default, length=length);
      } else if (is.logical(default)) {
        query <- "Enter logical value: ";
        ans <- textCharacterVector(query=query, default=default, length=length);
        ans <- as.logical(ans);
      }
      cat("New value:\n");
      print(ans);
      pa[[name]] <- ans;
    }
  } # while ()

  pa;
} # textPlotAnnotations()


extractTcgaSignals <- function(dsList, chromosome, region=NULL, kappa=1, ...) {
  ugp <- getAromaUgpFile(dsList$total);
  units0 <- getUnitsOnChromosome(ugp, chromosome=chromosome, region=region);

  # Extract allele B fractions
  ds <- dsList$fracB;
  dfT <- getFile(ds, 1);
  dfN <- getFile(ds, 2);

  # Identify SNPs only
  units <- units0;
str(units);
  betaN <- extractRawAlleleBFractions(dfN, chromosome=chromosome, units=units);
  units <- units[!is.na(getSignals(betaN))];
str(units);

  betaN <- extractRawAlleleBFractions(dfN, chromosome=chromosome, units=units);
  betaT <- extractRawAlleleBFractions(dfT, chromosome=chromosome, units=units);

  sampleName <- getName(dfN);
  betaN$name <- betaT$name <- sampleName;
  betaN$ylim <- betaT$ylim <- c(-0.1,1.1);

  # Extract total CNs
  ds <- dsList$total;
  dfT <- getFile(ds, 1);
  dfN <- getFile(ds, 2);
  thetaN <- extractRawCopyNumbers(dfN, chromosome=chromosome, units=units, logBase=NULL);
#print(thetaN$.yLogBase);
  thetaT <- extractRawCopyNumbers(dfT, chromosome=chromosome, units=units, logBase=NULL);
#print(thetaT$.yLogBase);
  thetaT$y <- 2 * thetaT$y/thetaN$y;
  C <- thetaT;

  C$name <- sampleName;
  C$col <- "black";
  C$ylim <- c(0,6);

  #Purify
  c <- C$y;
  bT <- betaT$y;
  cTA <- (1-bT)*c;
  cTB <- bT*c;
  bN <- betaN$y;
  cNA <- (1-bN)*2;
  cNB <- bN*2;
  cTA <- (cTA - (1-kappa)*cNA)/kappa;
  cTB <- (cTB - (1-kappa)*cNB)/kappa;
  cT <- cTA+cTB;
  bT <- cTB/cT;

  Cp <- clone(C);
  Cp$y <- cT;
  betaTp <- clone(betaT);
  betaTp$y <- bT;

  # Call genotypes
  muN <- callGenotypes(betaN);

  # TumorBoost
  betaTN <- normalizeTumorBoost(betaT, betaN=betaN, muN=muN);
  betaTpN <- normalizeTumorBoost(betaTp, betaN=betaN, muN=muN);

  # All beta tracks
  betaList <- list(betaT=betaT, betaN=betaN, betaTN=betaTN, 
                   betaTp=betaTp, betaTpN=betaTpN);

  # Add colors
  colorMap <- c(AA="red", AB="black", BB="red", "NA"="#999999");
  colorMap <- c(AA="#999999", AB="#000000", BB="#999999", "NA"="#cccccc");
  col <- getColors(muN, colorMap=colorMap);
  betaList <- lapply(betaList, FUN=function(beta) {
    beta$col <- col;
    addLocusFields(beta, "col");
    beta$yAt <- c(0,1/2,1);
    beta;
  })

  # Add heterozygous tracks
  hets <- which(isHeterozygous(muN));
  betaHetList <- lapply(betaList, FUN=extractSubset, hets);
  names(betaHetList) <- paste(names(betaHetList), "Het", sep="");
  betaList <- c(betaList, betaHetList);


  # Add rho tracks to each beta track
  rhoList <- lapply(betaList, FUN=function(beta) {
    rho <- extractRawMirroredAlleleBFractions(beta);
    rho$y <- 2*rho$y;
    rho$ylim <- c(0,1.1);
    rho;
  });
  names(rhoList) <- gsub("beta", "rho", names(rhoList));
  
  res <- list(C=C, Cp=Cp, muN=muN);
  res <- c(res, betaList, rhoList);

  res;
} # extractTcgaSignals()


extractTcgaPairs <- function(ds, ...) {
  library("aroma.tcga");
  library("gsubfn");
  ps <- BiospecimenCoreResource$getBarcodePatterns();
  pattern <- ps$aliqoutBarcode;
  setFullNamesTranslator(ds, function(names, ...) {
    strapply(names, pattern=pattern, FUN=function(...) {
      x <- unlist(list(...)); n <- length(x);
      sprintf("%s,%s", x[2], x[6]);
    });
  });

  # tumor-normal pairs
  names <- getNames(ds);
  t <- table(names);
  keep <- names[t == 2];
  dsT <- extract(ds, unique(keep));
  names <- getFullNames(dsT);
  dsT <- extract(dsT, order(names));

  dsT;
} # extractTcgaPairs()

library("R.utils");
verbose <- Arguments$getVerbose(-8, timestamp=TRUE);


verbose && enter(verbose, "Downloading annotation data for all tests");

verbose && enter(verbose, "Scanning tests");
path <- system.file("testScripts", package="aroma.cn");
verbose && cat(verbose, "Path to testScripts: ", path);

pattern <- "downloadAnnotationData.R$";
pathnames <- list.files(path=path, pattern=pattern, full.names=TRUE, recursive=TRUE);

nbrOfTestSets <- length(pathnames);
for (kk in seq_len(nbrOfTestSets)) {
  pathname <- pathnames[kk];
  dropPattern <- sprintf("^%s/", path);
  testSet <- gsub(dropPattern, "", dirname(pathname));
  verbose && enter(verbose, sprintf("Test set #%s ('%s') of %s", kk, testSet, nbrOfTestSets));
  sourceTo(pathname, envir=new.env(), echo=as.logical(verbose));
  verbose && exit(verbose);
} # for (kk ...)

verbose && exit(verbose);


verbose && exit(verbose);

loadAllDataSets <- function(dataSet, chipType="*", pattern=NULL, ..., rootPath="totalAndFracBData", type=c("fracB", "total", "genotypes", "confidenceScores"), verbose=FALSE) {
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## Validate arguments
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## Argument 'dataSet':
  dataSet <- Arguments$getCharacter(dataSet);

  ## Argument 'chipType':
  chipType <- Arguments$getCharacter(chipType);

  ## Argument 'pattern':
  if (is.null(pattern)) {
    pattern <- sprintf("^%s(|,.*)", dataSet);
  }
  pattern <- Arguments$getRegularExpression(pattern);

  ## Argument 'rootPath':
  rootPath <- Arguments$getReadablePath(rootPath, mustExist=TRUE);

  ## Argument 'type':
  type <- match.arg(type, c("fracB", "total", "genotypes", "confidenceScores"))

  ## Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose);
  if (verbose) {
    pushState(verbose);
    on.exit(popState(verbose));
  }


  verbose && enter(verbose, "loadAllDataSets()");


  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## Identify all data sets
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Scanning directory for data sets");
  verbose && cat(verbose, "Path: ", rootPath);
  verbose && cat(verbose, "Pattern: ", pattern);
  ## Search for directories and links
  paths <- list.files(path=rootPath, pattern=pattern, full.names=TRUE);
  verbose && cat(verbose, "Located paths:");
  verbose && print(verbose, paths);
  paths <- sapply(paths, FUN=Arguments$getReadablePath);
  paths <- paths[sapply(paths, FUN=isDirectory)];
  dataSets <- basename(paths);
  verbose && cat(verbose, "Located data sets:");
  verbose && print(verbose, dataSets);
  verbose && exit(verbose);

  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ## Setup data sets
  ## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  dsList <- list();
  verbose && enter(verbose, "Loading data sets");
  for (kk in seq_along(dataSets)) {
    dataSet <- dataSets[kk];
    verbose && enter(verbose, sprintf("Data set #%d ('%s') of %d",
                                      kk, dataSet, length(dataSets)));
    verbose && cat(verbose, "Type: ", type);

    if (type=="total") {
      ds <- AromaUnitTotalCnBinarySet$byName(dataSet, chipType=chipType, paths=rootPath);
    } else if (type=="fracB") {
      ds <- AromaUnitFracBCnBinarySet$byName(dataSet, chipType=chipType, paths=rootPath);
    } else if (type=="genotypes") {
      ds <- AromaUnitGenotypeCallSet$byName(dataSet, chipType=chipType);
    } else if (type=="confidenceScores") {
      ds <- AromaUnitSignalBinarySet$byName(dataSet, chipType=chipType, pattern="confidenceScores", paths=rootPath);
    }
    if (length(ds)) {
      dsList[[kk]] <- ds;
      verbose && print(verbose, ds);
    } else {
      verbose && cat(verbose, "No such data set found.");
    }
    verbose && exit(verbose);
  } # for (kk ...)
  verbose && exit(verbose);

  ## Drop empty data sets
  dsList <- dsList[sapply(dsList, FUN=length) > 0];
  
  ## Set the names
  names <- sapply(dsList, FUN=getFullName);
  names(dsList) <- names;

  verbose && cat(verbose, "Loaded data sets:");
  verbose && print(verbose, dsList);

  verbose && exit(verbose);

  dsList;
} ## loadAllDataSets()



############################################################################
## HISTORY:
## 2009-02-23
## o Created.
############################################################################

library("aroma.affymetrix")
library("aroma.cn");

log <- verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
figForce <- TRUE;

dsName <- "GSE20584";
chipType <- "GenomeWideSNP_6";

pairs <- matrix(c("GSM517071", "GSM517072"), ncol=2, byrow=TRUE);
colnames(pairs) <- c("tumor", "normal");

## paths
rootPath <- "totalAndFracBData";
rootPath <- Arguments$getWritablePath(rootPath);

dsTags <- "ACC,ra,-XY,BPN,-XY,AVG,FLN,-XY";

totalPath <- rootPath;
fracBPath <- rootPath;

dataSet <- sprintf("%s,%s", dsName, dsTags);

############################################################################
## 2010-09-15
## o Created.
############################################################################

library("R.utils");
verbose <- Arguments$getVerbose(-8, timestamp=TRUE);


verbose && enter(verbose, "Installing additional packages for all tests");

verbose && enter(verbose, "Scanning tests");
path <- system.file("testScripts", package="aroma.cn");
verbose && cat(verbose, "Path to testScripts: ", path);

pattern <- "installPackages.R$";
pathnames <- list.files(path=path, pattern=pattern, full.names=TRUE, recursive=TRUE);

nbrOfTestSets <- length(pathnames);
for (kk in seq_len(nbrOfTestSets)) {
  pathname <- pathnames[kk];
  dropPattern <- sprintf("^%s/", path);
  testSet <- gsub(dropPattern, "", dirname(pathname));
  verbose && enter(verbose, sprintf("Test set #%s ('%s') of %s", kk, testSet, nbrOfTestSets));
  sourceTo(pathname, envir=new.env(), echo=as.logical(verbose));
  verbose && exit(verbose);
} # for (kk ...)

verbose && exit(verbose);


verbose && exit(verbose);

library("aroma.cn");
library("PSCBS");
library("R.devices");
library("R.menu");
verbose <- Arguments$getVerbose(-10);

# Local functions
deShearC1C2 <- deShearC1C2_20120922;

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Local functions
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethodS3("doPlots", "PairedPSCBS", function(fit, sampleName=NULL, tags=NULL, ...) {
  # Argument 'sampleName':
  if (is.null(sampleName)) {
    sampleName <- sampleName(fit);
  }
  stopifnot(!is.null(sampleName));

  nCPsTag <- sprintf("#CPs=%d", nbrOfChangePoints(fit));
  toPNG(sampleName, tags=c("(C1,C2)", nCPsTag, tags), width=800, {
    plotC1C2Grid(fit);
    linesC1C2(fit);
    stext(side=3, pos=0, sampleName);
    stext(side=3, pos=1, nCPsTag);
    stext(side=4, pos=0, dataSet, cex=0.7);
    stext(side=4, pos=1, chipType, cex=0.7);
  });


  toPNG(sampleName, tags=c("tracks", nCPsTag, tags), width=1200, aspectRatio=0.25, {
    plotTracks(fit, tracks="tcn,c1,c2");
    stext(side=4, pos=0, sampleName);
    stext(side=4, pos=1, nCPsTag);
  });
}) # doPlots()



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup Paired PSCBS segmentation data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
rootPath <- "pscbsData";
path <- Arguments$getReadablePath(rootPath);

dataSets <- list.files(rootPath);
if (length(dataSets) > 1) {
 dataSet <- textMenu(dataSets, value=TRUE);
} else {
 dataSet <- dataSets[1];
}

path <- file.path(rootPath, dataSet);
path <- Arguments$getReadablePath(path);
chipTypes <- list.files(path);
if (length(chipTypes) > 1) {
 chipType <- textMenu(chipTypes, value=TRUE);
} else {
 chipType <- chipTypes[1];
}

ds <- PairedPSCBSFileSet$byName(dataSet, chipType=chipType);
print(ds);
dsName <- getName(ds);

if (length(ds) == 0) {
 throw("No PairedPSCBS data file found.")
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Select tumor-normal pair
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (length(ds) > 1) {
 ii <- textMenu(getNames(ds));
} else {
 ii <- 1L;
}

if (!exists("fit") || !inherits(fit, "PairedPSCBS")) {
  df <- getFile(ds, ii);
  fit <- loadObject(df);
  sampleName <- getName(df);
  rm(segList, fitList);
}

fit0 <- fit;

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Configure report
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
figPath <- file.path("figures", dataSet);
options("devEval/args/path"=figPath);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Plot (C1,C2)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
doPlots(fit);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Prune change points using dynamic programming
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (!exists("segList", mode="list")) {
  segList <- seqOfSegmentsByDP(fit, verbose=-10);
  modelFit <- attr(segList, "modelFit");
  modelFit$seqOfSegmentsByDP <- NULL;
  str(modelFit);
}


toPNG(sampleName, tags=c("DP", "RSEvsCPs"), width=800, aspectRatio=0.7, {
  plot(modelFit$nbrOfChangePoints, modelFit$rse,
       xlab="Number of change points", ylab="RSE");
  stext(side=3, pos=0, sampleName);
  stext(side=4, pos=0, dataSet, cex=0.7);
  stext(side=4, pos=1, chipType, cex=0.7);
});


nbrOfCPs <- c(100, 50, 25)[1:2];
if (!exists("fitList", mode="list")) {
  fitList <- list();
}
for (kk in seq_along(nbrOfCPs)) {
  key <- sprintf("nbrOfCPs=%d", nbrOfCPs[kk]);

  verbose && enter(verbose, sprintf("Change point set #%d ('%s') of %d", kk, key, length(nbrOfCPs)));

  verbose && cat(verbose, "Number of change points: ", nbrOfCPs[kk]);

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Pruning CPs via dynamic programming
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fitT <- fitList[[key]];
  if (is.null(fitT)) {
    verbose && enter(verbose, "Resegmenting");
    knownSegments <- segList[[nbrOfCPs[kk]+1L]];
    fitT <- resegment(fit, knownSegments=knownSegments, undoTCN=+Inf, undoDH=+Inf);
    fitList[[key]] <- fitT;
    verbose && exit(verbose);
  }
  sampleName(fitT) <- sampleName(fit);
  fitDP <- fitT;
  doPlots(fitDP);


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Deshear
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fitD <- deShearC1C2(fitDP);
  doPlots(fitD, tags="deShear");

  nCPsTag <- sprintf("#CPs=%d", nbrOfChangePoints(fitD));
  toPNG(sampleName, tags=c("cpCallDensity", nCPsTag, "deShear"), width=800, aspectRatio=0.5, {
    debug <- fitD$modelFit$debug;
    d <- debug$cpAngleDensity;
    pfp <- debug$pfp;
    expected <- attr(pfp, "expected");
    par(mar=c(5,4,2,2));
    plot(d, lwd=2, main="");
    abline(v=expected);
    text(x=expected, y=par("usr")[4], names(expected), adj=c(0.5,-0.5), cex=1.5, xpd=TRUE);

    # Annotate called peaks
    idxs <- match(pfp$call, expected);
    text(x=pfp$x, y=pfp$density, names(expected)[idxs], adj=c(0.5,-0.5), cex=1.5, col="blue");

    stext(side=4, pos=0, sampleName);
    stext(side=4, pos=1, nCPsTag);
  });

  verbose && exit(verbose);
} # for (kk ...)

library("aroma.cn");
library("PSCBS");
library("R.devices");
library("R.menu");
verbose <- Arguments$getVerbose(-10);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup Paired PSCBS segmentation data set
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
rootPath <- "pscbsData";
path <- Arguments$getReadablePath(rootPath);

dataSets <- list.files(rootPath);
if (length(dataSets) > 1) {
 dataSet <- textMenu(dataSets, value=TRUE);
} else {
 dataSet <- dataSets[1];
}

path <- file.path(rootPath, dataSet);
path <- Arguments$getReadablePath(path);
chipTypes <- list.files(path);
if (length(chipTypes) > 1) {
 chipType <- textMenu(chipTypes, value=TRUE);
} else {
 chipType <- chipTypes[1];
}

ds <- PairedPSCBSFileSet$byName(dataSet, chipType=chipType);
print(ds);
dsName <- getName(ds);

if (length(ds) == 0) {
 throw("No PairedPSCBS data file found.")
}


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Select tumor-normal pair
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
if (length(ds) > 1) {
 ii <- textMenu(getFullNames(ds));
} else {
 ii <- 1L;
}

df <- getFile(ds, ii);
fit <- loadObject(df);
sampleName <- getFullName(df);
sampleName <- gsub(",PairedPSCBS", "", sampleName, fixed=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# REPORT
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
tryCatch({
  report(fit, rspTags="deShear", sampleName=sampleName, studyName=dataSet, force=TRUE);
}, error=function(ex) {
  .lastError <<- ex;
});

library("R.utils");
if (interactive()) library("R.menu");
verbose <- Arguments$getVerbose(-8, timestamp=TRUE);


verbose && enter(verbose, "Removing all generated data");

verbose && cat(verbose, "This will *not* remove annotation data or raw data sets.");

# Root directories to be removed, iff existing
paths <- c(
  "probeData/",
  "plmData/",
  "qcData/",
  "firmaData/",
  "cbsData/",
  "gladData/",
  "haarData/",
  "totalAndFracBData/",
  "totalAndFracBData,txt/",
  "oligoData/",
  "crlmmData/",
  "Data/",
  "rawCnData/",
  "smoothCnData/",
  "reports/",
  "figures/"
);

# Identify which exists
keep <- sapply(paths, FUN=isDirectory);
paths <- paths[keep];

if (length(paths) > 0) {
  paths <- selectMenu(paths, selected=TRUE, title="Root directories to be removed");
  verbose && cat(verbose, "Root directories to be removed:");
  verbose && cat(verbose, paste(paths, collapse="\n"));
  
  
  for (kk in seq_along(paths)) {
    path <- paths[kk];
    verbose && enter(verbose, sprintf("Root directory #%s ('%s') of %s", kk, path, length(paths)));
    removeDirectory(path, recursive=TRUE);
    verbose && exit(verbose);
  } # for (kk ...)
} else {
  verbose && cat(verbose, "No root directories available. Skipping!");
}

verbose && exit(verbose);

#!/usr/bin/env bash

chipTypes=""
chipTypes="$chipTypes Test3"
chipTypes="$chipTypes HG-U133_Plus_2"
chipTypes="$chipTypes Mapping10K_Xba142"
chipTypes="$chipTypes Mapping50K_Hind240"
## chipTypes="$chipTypes Mapping50K_Hind240,Xba240"  ## TO UPDATE
chipTypes="$chipTypes Mapping250K_Nsp"
chipTypes="$chipTypes Mapping250K_Sty"
chipTypes="$chipTypes GenomeWideSNP_5"
chipTypes="$chipTypes GenomeWideSNP_6"
chipTypes="$chipTypes Cytogenetics_Array"
chipTypes="$chipTypes CytoScanHD_Array"
chipTypes="$chipTypes MOUSEDIVm520650"
chipTypes="$chipTypes Hs_PromPR_v02"
chipTypes="$chipTypes HuEx-1_0-st-v2"
## chipTypes="$chipTypes MoGene-1_0-st-v1" ## Cannot to GCRMA bg(?!?)

for chipType in ${chipTypes}; do
 echo "nohupR testAll.R --devel --chipTypes ${chipType}"
 nohupR testAll.R --devel --chipTypes ${chipType} &
 sleep 2
done

## nohupR testAll.R --devel --chipTypes Mapping10K_Xba142 &
## nohupR testAll.R --devel --chipTypes Test3 &
## nohupR testAll.R --devel --chipTypes HG-U133_Plus_2 &
## nohupR testAll.R --devel --chipTypes Mapping50K_Hind240,Xba240 &
## nohupR testAll.R --devel --chipTypes Hs_PromPR_v02 &
## nohupR testAll.R --devel --chipTypes Mapping250K_Nsp,Sty &
## nohupR testAll.R --devel --chipTypes HuEx-1_0-st-v2 &
## nohupR testAll.R --devel --chipTypes GenomeWideSNP_5 &
## nohupR testAll.R --devel --chipTypes GenomeWideSNP_6 &
## nohupR testAll.R --devel --chipTypes Cytogenetics_Array &
## nohupR testAll.R --devel --chipTypes CytoScanHD_Array &
